#include "list_dict.h"

AFun afun0;
AFun afun2;
AFun afun1;

ATerm patternNineSepsMany = NULL;
ATerm patternNineSepsSingle = NULL;
ATerm patternNineSepsEmpty = NULL;
ATerm patternLayoutDefault = NULL;
ATerm patternSeparatedMany = NULL;
ATerm patternSeparatedSingle = NULL;
ATerm patternSeparatedEmpty = NULL;
ATerm patternModuleListModules = NULL;
ATerm patternModules2Many = NULL;
ATerm patternModules2Single = NULL;
ATerm patternModules2Empty = NULL;
ATerm patternModulesMany = NULL;
ATerm patternModulesSingle = NULL;
ATerm patternModulesEmpty = NULL;
ATerm patternModuleDefault = NULL;

/*
 * afun0 = list(x)
 * afun2 = "sep"
 * afun1 = l(x)
 *
 * patternNineSepsMany = [<term>,1,2,3,4,5,6,7,8,9,<list>]
 * patternNineSepsSingle = [<term>]
 * patternNineSepsEmpty = []
 * patternLayoutDefault = <str>
 * patternSeparatedMany = [<term>,l(<term>),"sep",l(<term>),<list>]
 * patternSeparatedSingle = [<term>]
 * patternSeparatedEmpty = []
 * patternModuleListModules = list(<term>)
 * patternModules2Many = [<term>,<list>]
 * patternModules2Single = [<term>]
 * patternModules2Empty = []
 * patternModulesMany = [<term>,<list>]
 * patternModulesSingle = [<term>]
 * patternModulesEmpty = []
 * patternModuleDefault = <str>
 *
 */

static ATerm _list_dict = NULL;

#define _list_dict_LEN 209

static char _list_dict_baf[_list_dict_LEN] = {
0x00,0x8B,0xAF,0x83,0x00,0x0B,0x3B,0x05,0x3C,0x69,0x6E,0x74,0x3E,0x00,0x00,0x09,
0x03,0x3C,0x5F,0x3E,0x01,0x00,0x03,0x03,0x04,0x05,0x06,0x05,0x5B,0x5F,0x2C,0x5F,
0x5D,0x02,0x00,0x25,0x07,0x02,0x03,0x00,0x01,0x08,0x09,0x0A,0x02,0x02,0x03,0x02,
0x5B,0x5D,0x00,0x00,0x01,0x03,0x73,0x74,0x72,0x00,0x00,0x01,0x04,0x6C,0x69,0x73,
0x74,0x00,0x00,0x01,0x04,0x74,0x65,0x72,0x6D,0x00,0x00,0x01,0x01,0x78,0x00,0x00,
0x01,0x04,0x6C,0x69,0x73,0x74,0x01,0x00,0x02,0x02,0x01,0x07,0x03,0x73,0x65,0x70,
0x00,0x01,0x01,0x01,0x6C,0x01,0x00,0x02,0x02,0x01,0x07,0x02,0x08,0x12,0x20,0xA0,
0x0C,0xA3,0x10,0x88,0xB3,0x08,0x62,0x08,0x00,0x00,0x00,0x03,0x45,0x08,0x00,0x00,
0x00,0x02,0x89,0x30,0x00,0x00,0x00,0x09,0x16,0x10,0x00,0x00,0x00,0x02,0x22,0xA0,
0x00,0x00,0x00,0x38,0x54,0xC0,0x00,0x00,0x00,0x30,0x9B,0x80,0x00,0x00,0x00,0xA1,
0x70,0x80,0x00,0x00,0x00,0x42,0x19,0x00,0x00,0x00,0x03,0x0D,0x51,0x08,0x73,0x10,
0x0C,0x3E,0xC8,0x3C,0x12,0xC1,0x13,0x80,0x0A,0x9E,0x38,0xC0,0xB8,0x38,0x1D,0x0D,
0x8C,0x02,0xC3,0x2C,0x18,0x13,0x07,0x01,0xA1,0xD0,0xC8,0x68,0x38,0x55,0x02,0xB3,
0x40
};

void init_list_dict()
{
  ATermList afuns, terms;

  _list_dict = ATreadFromBinaryString(_list_dict_baf, _list_dict_LEN);

  ATprotect(&_list_dict);

  afuns = (ATermList)ATelementAt((ATermList)_list_dict, 0);

  afun0 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  afun2 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  afun1 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);

  terms = (ATermList)ATelementAt((ATermList)_list_dict, 1);

  patternNineSepsMany = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternNineSepsSingle = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternNineSepsEmpty = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternLayoutDefault = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternSeparatedMany = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternSeparatedSingle = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternSeparatedEmpty = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternModuleListModules = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternModules2Many = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternModules2Single = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternModules2Empty = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternModulesMany = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternModulesSingle = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternModulesEmpty = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternModuleDefault = ATgetFirst(terms);
  terms = ATgetNext(terms);
}
